Subject: [PATCH 4/4] soc: mediatek: Add MT2701/MT7623 scpsys driver

From: [email-masked] (Matthias Brugger)
Date: Fri, 8 Jan 2016 12:26:29 +0100

On 05/01/16 06:23, James Liao wrote:
> Hi Matthias,
> On Wed, 2015-12-30 at 18:49 +0100, Matthias Brugger wrote:
>>> On Wed, 2015-12-30 at 17:01 +0800, Daniel Kurtz wrote:
>>>> On Wed, Dec 30, 2015 at 2:41 PM, James Liao <[email-masked]> wrote:
>>>>>
>>>>> From: Shunli Wang <[email-masked]>
>>>>>
>>>>> Add scpsys driver for MT2701 and MT7623.
>>>>>
>>>>> Signed-off-by: Shunli Wang <[email-masked]>
>>>>> Signed-off-by: James Liao <[email-masked]>
>>>>> ---
>>>>>    drivers/soc/mediatek/Kconfig             |  11 +++
>>>>>    drivers/soc/mediatek/Makefile            |   1 +
>>>>>    drivers/soc/mediatek/mtk-scpsys-mt2701.c | 161 +++++++++++++++++++++++++++++++
>>>>>    3 files changed, 173 insertions(+)
>>>>>    create mode 100644 drivers/soc/mediatek/mtk-scpsys-mt2701.c
>>>>>
>>>>> diff --git a/drivers/soc/mediatek/Kconfig b/drivers/soc/mediatek/Kconfig
>>>>> index eca6fb7..92cf838 100644
>>>>> --- a/drivers/soc/mediatek/Kconfig
>>>>> +++ b/drivers/soc/mediatek/Kconfig
>>>>> @@ -39,3 +39,14 @@ config MTK_SCPSYS_MT8173
>>>>>             driver.
>>>>>             The System Control Processor System (SCPSYS) has several power
>>>>>             management related tasks in the system.
>>>>> +
>>>>> +config MTK_SCPSYS_MT2701
>>>>> +       bool "SCPSYS Support MediaTek MT2701 and MT7623"
>>>>> +       depends on ARCH_MEDIATEK || COMPILE_TEST
>>>>> +       select MTK_SCPSYS
>>>>> +       default ARCH_MEDIATEK
>>>>> +       help
>>>>> +         Say yes here to add support for the MT2701/MT7623 SCPSYS power
>>>>> +         domain driver.
>>>>> +         The System Control Processor System (SCPSYS) has several power
>>>>> +         management related tasks in the system.
>>>>
>>>> I don't think we really want different drivers and Kconfig options.
>>>>
>>>> Can we just use different compatibles to select the appropriate scp_domain_data?
>>>
>>> Yes, we can. All scpsys drivers are built-in by default, and they will
>>> be activate by specific compatible string.
>>>
>>> But some projects don't want to build unused drivers into kernel to save
>>> code size. Use different Kconfig options for each SoC so that these
>>> projects can disable unused drivers.
>>>
>>
>> Scpsys is a bool right now, you can disable it if you don't need it for
>> your project.
>>
>> I don't think the impact of adding scp_domain_data justifies adding SoC
>> specific scpsys drivers and bloat the drivers/soc/mediatek folder.
>
> So you prefer to enable MT8173 and MT2701 scpsys drivers at the same
> time if MTK_SCPSYS is true?

Well the driver gets enabled by the compatible string from the DT 
binding passed to the system. But yes, I prefer to have the code shared 
and just add the necessary data structures.

>
> BTW, this patchset is based on 4.4-rc7, which lacks two patches from
> your v4.4-next/soc. Should I rebase to v4.4-next/soc when I send v2
> patch?
>

That would be a nice to have.

Thanks,
Matthias